do_answer stm)#output in
      ignore (Unix.sendto sck str 0 (String.length str) [] snew)

   method do_tcp sck =
      let fd, sockaddr = Unix.handle_unix_error (Unix.accept) sck in
      let str = String.create 4096 in
      (* we can read the first byte *)
      let size = Unix.handle_unix_error (Unix.recv fd str 0 4096) [] in
      let stm = Stream.of_string (String.sub str 0 size) in
      let one = Char.code (Stream.next stm)
      and two = Char.code (Stream.next stm) in
      let sz = one*256+two in
      begin
      match Unix.select [fd] ([]: Unix.file_descr list) ([]: Unix.file_descr list) 5. with
      | read, _ , _ when read != []-> ()
      | _, _, _ -> 
   	 Unix.shutdown fd Unix.SHUTDOWN_ALL
      end;
      let size = Unix.handle_unix_error (Unix.recv fd str 0 4096) [] in
      let stm = Stream.of_string (String.sub str 0 size) in
      if size = sz
      then
	 begin
	 let r = self#do_axfr (Tools.extract_stream stm size) in
	 if r != ""
	 then
	    ignore (Unix.send fd r 0 (String.length r) [])
	 end;
      Unix.shutdown fd Unix.SHUTDOWN_ALL;

   method do_axfr stm =
      let query = super#parse_packet stm in
      if query#get_qdcount = 1 
      then
	 begin
	 let tmp = List.hd query#get_questions in
	 if tmp#get_type = 252 && root#is_authoritative tmp#get_name
	 then
	    begin
	    let hd = new Dns.dns_data_header in
	    (* set the header *)
	    let id = query#get_id in
	    hd#set_id id; (* use the same id *)
	    hd#set_qr true; (* answer *)
	    hd#set_rd false; (* no recursion *)
	    hd#set_aa true; (* auth. answer *)
	    hd#set_rcode 0; (* No error *)
	    let tree = root#get_subtree tmp#get_name in
	    begin
	    if tree != []
	    then
	       self#do_tree tree tmp hd
	    else
	       ""
	    end
	    end
	 else
	    ""
	 end
      else
	 ""

   method private do_tree tree quer hdr =
      let rec parcours tree name hd =
      match tree with
      | [] -> ""
      | Dns.DomainName (str, lst1, lst2)::l -> 
	 (if lst2 != []
	 then
	    (List.fold_right (fun x -> fun y -> 
	       let temp = new Dns.dns_packet
	       and resp = new Dns.dns_data_answer in
               temp#add_question [quer];
	       resp#set_name (str^"."^name);
               (* little trick in order to use build packet *)
	       quer#set_name (str^"."^name); 
               temp#set_header hd;
	       self#build_packet quer temp x temp#add_answer;
	       let out = temp#output in
	       y^(Tools.hexa_of_int (String.length out) 2)^out)

	       lst2 "")
	 else
	    "")^
     	 (if l != []
	 then
	    parcours l name hd
	 else
	    "")^
	 (if lst1 != []
	 then
	    parcours lst1 (str^"."^name) hd
	 else
	    "")
      in
      let answ = new Dns.dns_packet in 
      answ#set_header hdr;
      self#add_soa quer#get_name answ answ#add_answer;
      let out = answ#output in
      let soa = (Tools.hexa_of_int (String.length out) 2)^out in
      soa^(parcours tree "" hdr)^soa

   method private do_answer stm =
      let query = super#parse_packet stm
      and answer = new Dns.dns_packet in
      (* set the header *)
      let id = query#get_id in
      answer#set_id id; (* use the same id *)
      answer#set_qr true; (* answer *)
      answer#set_rd false; (* no recursion *)
      answer#set_aa true; (* auth. answer *)
      (* parse query *)
      self#process_query query answer;
      (* return the answer *)
      answer
    
   method private process_query quer answ =
      let qst = quer#get_questions in
      answ#set_rcode 3; (* No Such Name error *)
      print_int (List.length qst);
      print_char '\n';
      for i=0 to List.length qst -1
      do
         let tmp = List.nth qst i in
	 answ#add_question [tmp];
         print_string "help\n";
         let dn = root#get_domain tmp#get_name in
	 if root#is_authoritative dn
	 then
            match tmp#get_type with
	    | 6 (* SOA *) -> 
	    (* SOA RR is build on the fly ... *)
               self#build_packet tmp answ 
                  (Dns.SOA (dn, contact, serial, refresh, retry, expire, ttl))
                  answ#add_answer
	    | _ ->
	       self#construct_answer tmp answ
      done;

   method private build_packet quer answ rrtype f =
      let temp = new Dns.dns_data_answer in
      temp#set_name quer#get_name;
      temp#set_type (Dnsprint.rrtype_to_int rrtype);
      temp#set_ttl ttl;
      temp#set_rdata rrtype;
      temp#set_class 1;
      answ#set_rcode 0; (* No error *)
      f [temp]

   method private construct_answer quer answ = 
   print_string ("groooar\n"); flush stdout;
    let name = String.lowercase quer#get_name in
    let rlt = root#get name
    and dn = root#get_domain name in
    print_string (name^"\n");
    match rlt with
    | [Dns.NotFound] ->
      self#add_soa dn answ answ#add_authority;
      answ#set_rcode 3; (* No such name *)
    | [] -> answ#set_rcode 0; (* No error *)
    | [Dns.CNAME str] as rrtl ->
          begin
      let rrt = List.hd rrtl in
      print_string "loop\n"; flush stdout;
      if quer#get_type != 5
      then
	 (* Hum, we got a cname and client didn't queried that ... *) 
	 begin
	 self#fiter quer answ rrt;
	 (* if we are authoritative ... *)
         let dn = root#get_domain quer#get_name in
	 if root#is_authoritative dn
	 then
	    begin
	 (* ... let's verify if we can add information *)
	    quer#set_name str;
	    quer#set_type 1; (* A *)
	    print_string ("=>"^quer#get_name^" "^(string_of_int quer#get_type)^"\n"); flush stdout;
	    self#construct_answer quer answ
	    end
	 end
      else 
	 self#fiter quer answ rrt
      end
    | lst ->
      List.iter (self#fiter quer answ) lst;
   if answ#get_ancount = -1 
   then
      (self#add_soa dn answ answ#add_authority; 
      answ#set_rcode 0) (* No error *)

   method private fiter quer answ x =
      if quer#get_type = 255
      then
	 self#build_packet quer answ x answ#add_answer
      else
         (*
	 begin	  
	 if (Dnsprint.rrtype_to_int x) = 5 (* CNAME *)
	 then
	    begin
	    self#build_packet quer answ x answ#add_answer;
	    print_string "CNAME detected\n";
	    print_string ((string_of_int quer#get_type)^"\n");
	    flush stdout;
	    end
	else
           *)
           begin
	    if (Dnsprint.rrtype_to_int x) = quer#get_type
	    then
		self#build_packet quer answ x answ#add_answer
	 end

   method private add_soa dn answ f=
      let t = new Dns.dns_data_question in
      t#set_name dn;
      t#set_type 6;
      self#build_packet t answ 
         (Dns.SOA (dn, contact, serial, refresh, retry, expire, ttl))
         f

end;;

let parse_args =
   let user = ref "" in
   let lst = []
   in
   Arg.parse lst (fun x -> user := x) "";
   !user
;;

let test = new dns_listen in
test#add "valadon.net" [Dns.MX (10, "adelscott.lanetcie.com")];
test#add "valadon.net" [Dns.MX (20, "test.lanetcie.com")];
test#add "valadon.net" [Dns.NS ("adelscott.lanetcie.com")];
test#add "www.valadon.net" [Dns.A "212.43.217.74"];
test#add "www.valadon.net" [Dns.A "212.43.217.75"];
test#add "www.valadon.net" [Dns.A "212.43.217.76"];
test#add "www.valadon.net" [Dns.HINFO ("pentoume zedou", "lunix")];
test#add "guillaume.valadon.net" [Dns.CNAME "www.valadon.net"];
test#add "cname.valadon.net" [Dns.CNAME "www.valadon.net"];
test#add "guillaume.valadon.net" [Dns.TXT "fuckin' alias"];
test#add "74.217.43.212.in-addr.arpa" [Dns.PTR "www.valadon.net"];

let user = parse_args in
Tools.daemonize "./tinyd.log" (test#action user);
