type 'a data = Data of 'a 
	     | Null;;

type ('a, 'b) entree = Leafe of 'a * ('a, 'b) entree list * 'b data;;

type ('a, 'b) et = {mutable contents: ('a, 'b) entree list};;

type 'a ntree = Leaf of string * 'a ntree list * 'a
	      | Node of string * 'a ntree list;;

type 'a t = {mutable contents: 'a ntree list};;

let create () =
   let ret = {contents = []} in
   ret
;;

let clear t = t.contents <- [];;
let set t1 t2 = t1.contents <- t2.contents;;

let put t s l = 
   let rec temp root str elt =
   let hd = List.hd str
   and tl = List.tl str in
   match root with
   | [] ->
      (match tl with
	 | [] ->
	       [Leaf (hd, [], elt)]
	 | _ ->
	       [Node (hd, temp [] tl elt)])
   | lst ->
      (let test = ref true
      and leafnull sl a b c e=
	 if sl = []
	 then
	    Leaf (a, b, elt)
	 else
	    Leaf (a, temp b tl e, c)
      and nodenull sl a b e=
	 if sl = []
	 then
	    Leaf (a, b, e)
	 else
	    Node (a, temp b tl e)
      in
      let tlst = List.map 

	 (fun x -> 
	 match x with
	 | Leaf (a, b, c) ->
	    (match a = hd with
	    | false -> Leaf (a,b,c)
	    | true -> test := false; leafnull tl a b c elt)
	 | Node (a, b) ->
	    (match a = hd with
	    | false -> Node (a,b)
	    | true -> test := false; nodenull tl a b elt)
	 )

	 lst in
      match !test with
      | false ->
	 tlst
      | true ->
	 lst@(temp [] str elt))
   in 
   t.contents <- temp t.contents s l
;;

let delete t l = t;;

let get t l =
(*
   let rec temp root lst =
   match root with
   | DomainName (str, domainlst, rrlst)::l
   when [str] = lst ->
      rrlst
   | DomainName (str, domainlst, rrlst)::l
   when str = (List.hd lst) ->
      temp domainlst (List.tl lst)
   | DomainName (_,_,_)::l ->
      temp l lst
   | [] -> 
   in
   temp root l
*)
t
;;

let get_subtree t l = t;;

let dump t f =
   let rec parcours tree name =
   match tree with
   | [] -> ()
   | Leaf (str, lst, elt)::l ->
      (print_string "Leaf: ";
      print_string (str^"->"^name^"\n");
      print_string "Element: \n";
      f elt;
      if l != []
      then
	 parcours l name;
      if lst != []
      then
	 (print_string "-_-_-_-_-_-\n";
	 parcours lst (str^"->"^name)))
   | Node (str, lst)::l -> 
      (print_string "Node: ";
      print_string (str^"->"^name^"\n");
      if l != []
      then
	 parcours l name;
      if lst != []
      then
	 (print_string "-_-_-_-_-_-\n";
	 parcours lst (str^"->"^name)))
   in
   parcours t.contents ""
;;

let test = create ();;
put test ["net"; "valadon"] 42;;
dump test (fun x -> print_int x; print_char '\n');;
